Codeforces Round #360 (Div. 2) E. The Values You Can Make 01背包

题目链接:

题目

E. The Values You Can Make
time limit per test:2 seconds
memory limit per test:256 megabytes

问题描述

Pari wants to buy an expensive chocolate from Arya. She has n coins, the value of the i-th coin is ci. The price of the chocolate is k, so Pari will take a subset of her coins with sum equal to k and give it to Arya.

Looking at her coins, a question came to her mind: after giving the coins to Arya, what values does Arya can make with them? She is jealous and she doesn't want Arya to make a lot of values. So she wants to know all the values x, such that Arya will be able to make x using some subset of coins with the sum k.

Formally, Pari wants to know the values x such that there exists a subset of coins with the sum k such that some subset of this subset has the sum x, i.e. there is exists some way to pay for the chocolate, such that Arya will be able to make the sum x using these coins.

输入

The first line contains two integers n and k (1  ≤  n, k  ≤  500) — the number of coins and the price of the chocolate, respectively.

Next line will contain n integers c1, c2, ..., cn (1 ≤ ci ≤ 500) — the values of Pari's coins.

It's guaranteed that one can make value k using these coins.

输出

First line of the output must contain a single integer q— the number of suitable values x. Then print q integers in ascending order — the values that Arya can make for some subset of coins of Pari that pays for the chocolate.

样例

input
6 18
5 6 1 10 12 2

output
16
0 1 2 3 5 6 7 8 10 11 12 13 15 16 17 18

题意

求原序列中子序和为k的子序列的子序列能构成的所有不同的子序和。

题解

由于数据<=500,所以可以n^3 dp。
设dp[i][j][k]表示前面i个数能构成的子序和为j的子序列能构造出自序和为k的数子序列。
然后类似01背包考虑选或不选的情况。

代码

#include<iostream>
#include<cstdio>
#include<cstring>
#include<vector>
using namespace std;

const int maxn = 1010;
int n, m;

bool dp[2][maxn][maxn];
int arr[maxn], vis[maxn];

int main() {
	scanf("%d%d", &n, &m);
	for (int i = 1; i <= n; i++) {
		scanf("%d", &arr[i]);
	}
	memset(dp, 0, sizeof(dp));
	dp[0][0][0] = 1;
	int cur = 0;
	for (int i = 1; i <= n; i++) {
		cur ^= 1;
		memset(dp[cur], 0, sizeof(dp[cur]));
		for (int j = 0; j <= m; j++) {
			for (int k = 0; k <= m; k++) {
				if (dp[cur^1][j][k]) {
					dp[cur][j][k] = 1;
					dp[cur][j + arr[i]][arr[i]] = 1;
					dp[cur][j + arr[i]][k] = 1;
					dp[cur][j + arr[i]][k + arr[i]] = 1;
				}
			}
		}
	}
	vector<int> ans;
	for (int k = 0; k <= m; k++) {
		if (dp[cur][m][k]) ans.push_back(k);
	}
	printf("%d
", ans.size());
	for (int i = 0; i < ans.size() - 1; i++) printf("%d ", ans[i]);
	printf("%d
",ans[ans.size()-1]);
	return 0;
}

总结

在数据范围允许情况下,考虑越高维的dp往往更能简化问题。

原文地址:https://www.cnblogs.com/fenice/p/5658957.html